Scala Standard Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
    - `scala.collection.parallel.immutable` - Immutable, parallel data-structures such as `ParVector`, `ParRange`, `ParHashMap` or `ParHashSet`
    - `scala.collection.parallel.mutable` - Mutable, parallel data-structures such as `ParArray`, `ParHashMap`, `ParTrieMap` or `ParHashSet`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection

  Contains the base traits and objects needed to use and extend Scala's collection library.

  Contains the base traits and objects needed to use and extend Scala's collection library.

  #### Guide

  A detailed guide for using the collections library is available at http://docs.scala-lang.org/overviews/collections/introduction.html. Developers looking to extend the collections library can find a description of its architecture at http://docs.scala-lang.org/overviews/core/architecture-of-scala-collections.html.

  #### Using Collections

  It is convenient to treat all collections as either a scala.collection.Traversable or scala.collection.Iterable, as these traits define the vast majority of operations on a collection.

  Collections can, of course, be treated as specifically as needed, and the library is designed to ensure that the methods that transform collections will return a collection of the same type:

      scala> val array = Array(1,2,3,4,5,6)
      array: Array[Int] = Array(1, 2, 3, 4, 5, 6)

      scala> array map { _.toString }
      res0: Array[String] = Array(1, 2, 3, 4, 5, 6)

      scala> val list = List(1,2,3,4,5,6)
      list: List[Int] = List(1, 2, 3, 4, 5, 6)

      scala> list map { _.toString }
      res1: List[String] = List(1, 2, 3, 4, 5, 6)

  #### Creating Collections

  The most common way to create a collection is to use its companion object as a factory. The three most commonly used collections are scala.collection.Seq, scala.collection.immutable.Set, and scala.collection.immutable.Map. They can be used directly as shown below since their companion objects are all available as type aliases in either the scala package or in `scala.Predef`. New collections are created like this:

      scala> val seq = Seq(1,2,3,4,1)
      seq: Seq[Int] = List(1, 2, 3, 4, 1)

      scala> val set = Set(1,2,3,4,1)
      set: scala.collection.immutable.Set[Int] = Set(1, 2, 3, 4)

      scala> val map = Map(1 -> "one", 2 -> "two", 3 -> "three", 2 -> "too")
      map: scala.collection.immutable.Map[Int,String] = Map(1 -> one, 2 -> too, 3 -> three)

  It is also typical to prefer the scala.collection.immutable collections over those in scala.collection.mutable; the types aliased in the `scala.Predef` object are the immutable versions.

  Also note that the collections library was carefully designed to include several implementations of each of the three basic collection types. These implementations have specific performance characteristics which are described in the guide.

  The concrete parallel collections also have specific performance characteristics which are described in the parallel collections guide

  ##### Converting to and from Java Collections

  The scala.collection.JavaConverters object provides a collection of decorators that allow converting between Scala and Java collections using `asScala` and `asJava` methods.

  Definition Classes
    scala
-  package concurrent
  Definition Classes
    collection
-  package convert
  Definition Classes
    collection
-  package generic
  Definition Classes
    collection
-  package immutable
  Definition Classes
    collection
-  package mutable
  Definition Classes
    collection
-  package parallel

  Package object for parallel collections.

  Package object for parallel collections.

  Definition Classes
    collection
-  package script
  Definition Classes
    collection
- +:
- :+
- AbstractIterable
- AbstractIterator
- AbstractMap
- AbstractSeq
- AbstractSet
- AbstractTraversable
- BitSet
- BitSetLike
- BufferedIterator
- CustomParallelizable
- DefaultMap
- GenIterable
- GenIterableLike
- GenMap
- GenMapLike
- GenSeq
- GenSeqLike
- GenSet
- GenSetLike
- GenTraversable
- GenTraversableLike
- GenTraversableOnce
- IndexedSeq
- IndexedSeqLike
- IndexedSeqOptimized
- Iterable
- IterableLike
- IterableProxy
- IterableProxyLike
- IterableView
- IterableViewLike
- Iterator
- JavaConversions
- JavaConverters
- LinearSeq
- LinearSeqLike
- LinearSeqOptimized
- Map
- MapLike
- MapProxy
- MapProxyLike
- Parallel
- Parallelizable
- Searching
- Seq
- SeqLike
- SeqProxy
- SeqProxyLike
- SeqView
- SeqViewLike
- Set
- SetLike
- SetProxy
- SetProxyLike
- SortedMap
- SortedMapLike
- SortedSet
- SortedSetLike
- Traversable
- TraversableLike
- TraversableOnce
- TraversableProxy
- TraversableProxyLike
- TraversableView
- TraversableViewLike
- ViewMkString

t

scala.collection

# GenTraversableOnce 

###

#### trait GenTraversableOnce[+A] extends Any

A template trait for all traversable-once objects which may be traversed in parallel.

Methods in this trait are either abstract or can be implemented in terms of other methods.

Source
  GenTraversableOnce.scala

Linear Supertypes
Any
Known Subclasses
ValueSet, AbstractIterable, AbstractIterator, AbstractMap, AbstractSeq, AbstractSet, AbstractTraversable, BitSet, BitSetLike, BufferedIterator, DefaultMap, GenIterable, GenIterableLike, GenMap, GenMapLike, GenSeq, GenSeqLike, GenSet, GenSetLike, GenTraversable, GenTraversableLike, IndexedSeq, IndexedSeqLike, Elements, IndexedSeqOptimized, Iterable, IterableLike, IterableView, IterableViewLike, Appended, DroppedWhile, EmptyView, Filtered, FlatMapped, Forced, Mapped, Prepended, Sliced, TakenWhile, Transformed, Zipped, ZippedAll, Iterator, GroupedIterator, LinearSeq, LinearSeqLike, LinearSeqOptimized, Map, WithDefault, MapLike, DefaultKeySet, DefaultValuesIterable, FilteredKeys, MappedValues, Seq, SeqLike, SeqView, SeqViewLike, Appended, DroppedWhile, EmptyView, Filtered, FlatMapped, Forced, Mapped, Patched, Prepended, Reversed, Sliced, TakenWhile, Transformed, Zipped, ZippedAll, Set, SetLike, SortedMap, SortedMapLike, DefaultKeySortedSet, SortedSet, SortedSetLike, Traversable, TraversableLike, TraversableOnce, TraversableView, TraversableViewLike, Appended, DroppedWhile, EmptyView, Filtered, FlatMapped, Forced, Mapped, Prepended, Sliced, TakenWhile, Transformed, Map, TrieMap, ::, AbstractMap, BitSet, BitSet1, BitSet2, BitSetN, DefaultMap, HashMap, HashMap1, HashTrieMap, HashSet, HashTrieSet, IndexedSeq, Impl, IntMap, Iterable, LinearSeq, List, ListMap, Node, ListSet, Node, LongMap, Map, Map1, Map2, Map3, Map4, WithDefault, MapLike, ImmutableDefaultKeySet, Nil, NumericRange, Exclusive, Inclusive, Queue, Range, Inclusive, Seq, Set, Set1, Set2, Set3, Set4, SortedMap, DefaultKeySortedSet, SortedSet, Stream, Cons, Empty, StreamIterator, StreamView, StreamViewLike, Appended, DroppedWhile, EmptyView, Filtered, FlatMapped, Forced, Mapped, Patched, Prepended, Reversed, Sliced, TakenWhile, Transformed, Zipped, ZippedAll, StringLike, StringOps, Traversable, TreeMap, TreeSet, Vector, VectorIterator, WrappedString, AbstractBuffer, AbstractIterable, AbstractMap, AbstractSeq, AbstractSet, AbstractSortedMap, AbstractSortedSet, AnyRefMap, ArrayBuffer, ArrayLike, ArrayOps, ofBoolean, ofByte, ofChar, ofDouble, ofFloat, ofInt, ofLong, ofRef, ofShort, ofUnit, ArraySeq, ArrayStack, BitSet, Buffer, BufferLike, HashMap, HashSet, History, IndexedSeq, IndexedSeqLike, IndexedSeqOptimized, IndexedSeqView, DroppedWhile, Filtered, Reversed, Sliced, TakenWhile, Transformed, Iterable, LinearSeq, LinkedHashMap, DefaultKeySet, FilteredKeys, MappedValues, LinkedHashSet, ListBuffer, ListMap, LongMap, Map, WithDefault, MapLike, MultiMap, MutableList, OpenHashMap, PriorityQueue, Queue, ResizableArray, RevertibleHistory, Seq, SeqLike, Set, SetLike, SortedMap, SortedSet, StringBuilder, Traversable, TreeMap, TreeSet, UnrolledBuffer, WrappedArray, ofBoolean, ofByte, ofChar, ofDouble, ofFloat, ofInt, ofLong, ofRef, ofShort, ofUnit, IterableSplitter, Appended, Mapped, Taken, Zipped, ZippedAll, ParIterable, ParIterableLike, ParMap, WithDefault, ParMapLike, DefaultKeySet, DefaultValuesIterable, ParSeq, ParSeqLike, Elements, ParSet, ParSetLike, PreciseSplitter, SeqSplitter, Appended, Mapped, Patched, Taken, Zipped, ZippedAll, Splitter, ParHashMap, ParHashMapIterator, ParHashSet, ParHashSetIterator, ParIterable, ParMap, WithDefault, ParRange, ParRangeIterator, ParSeq, ParSet, ParVector, ParVectorIterator, ParArray, ParArrayIterator, ParFlatHashTableIterator, ParHashMap, ParHashMapIterator, ParHashSet, ParHashSetIterator, EntryIterator, ParIterable, ParMap, WithDefault, ParMapLike, ParSeq, ParSet, ParSetLike, ParTrieMap, BufferedSource, BufferedLineIterator, Source, LineIterator, SystemProperties, MatchIterator, IterableProxy, IterableProxyLike, MapProxy, MapProxyLike, SeqProxy, SeqProxyLike, SetProxy, SetProxyLike, TraversableProxy, TraversableProxyLike, IterableForwarder, SeqForwarder, TraversableForwarder, MapProxy, PagedSeq, SetProxy, Stack, BufferProxy, DefaultMapModel, DoubleLinkedList, DoubleLinkedListLike, ImmutableMapAdaptor, ImmutableSetAdaptor, LinkedList, LinkedListLike, MapProxy, ObservableBuffer, ObservableMap, ObservableSet, PriorityQueueProxy, QueueProxy, SetProxy, Stack, StackProxy, SynchronizedBuffer, SynchronizedMap, SynchronizedPriorityQueue, SynchronizedQueue, SynchronizedSet, SynchronizedStack, Script
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. GenTraversableOnce
2. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1.  abstract def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this collection or iterator.

2.  abstract def :\[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this collection or iterator.

3.  abstract def aggregate[B](z: ⇒ B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

   Aggregates the results of applying an operator to subsequent elements.

   Aggregates the results of applying an operator to subsequent elements.

   This is a more general form of `fold` and `reduce`. It is similar to `foldLeft` in that it doesn't require the result to be a supertype of the element type. In addition, it allows parallel collections to be processed in chunks, and then combines the intermediate results.

   `aggregate` splits the collection or iterator into partitions and processes each partition by sequentially applying `seqop`, starting with `z` (like `foldLeft`). Those intermediate results are then combined by using `combop` (like `fold`). The implementation of this operation may operate on an arbitrary number of collection partitions (even 1), so `combop` may be invoked an arbitrary number of times (even 0).

   As an example, consider summing up the integer values of a list of chars. The initial value for the sum is 0. First, `seqop` transforms each input character to an Int and adds it to the sum (of the partition). Then, `combop` just needs to sum up the intermediate results of the partitions:

       List('a', 'b', 'c').aggregate(0)({ (sum, ch) => sum + ch.toInt }, { (p1, p2) => p1 + p2 })

   B

     the type of accumulated results

   z

     the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

   seqop

     an operator used to accumulate results within a partition

   combop

     an associative operator used to combine results from different partitions

4.  abstract def count(p: (A) ⇒ Boolean): Int

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     the number of elements satisfying the predicate `p`.

5.  abstract def exists(p: (A) ⇒ Boolean): Boolean

   Tests whether a predicate holds for at least one element of this collection or iterator.

   Tests whether a predicate holds for at least one element of this collection or iterator.

   Note: may not terminate for infinite-sized collections.

   p

     the predicate used to test elements.

   returns

     `true` if the given predicate `p` is satisfied by at least one element of this collection or iterator, otherwise `false`

6.  abstract def find(p: (A) ⇒ Boolean): Option[A]

   Finds the first element of the collection or iterator satisfying a predicate, if any.

   Finds the first element of the collection or iterator satisfying a predicate, if any.

   Note: may not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   p

     the predicate used to test elements.

   returns

     an option value containing the first element in the collection or iterator that satisfies `p`, or `None` if none exists.

7.  abstract def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

   Folds the elements of this collection or iterator using the specified associative binary operator.

   Folds the elements of this collection or iterator using the specified associative binary operator.

   The order in which operations are performed on elements is unspecified and may be nondeterministic.

   Note: will not terminate for infinite-sized collections.

   A1

     a type parameter for the binary operator, a supertype of `A`.

   z

     a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication).

   op

     a binary operator that must be associative.

   returns

     the result of applying the fold operator `op` between all the elements and `z`, or `z` if this collection or iterator is empty.

8.  abstract def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

         op(...op(z, x_1), x_2, ..., x_n)

     where `x1, ..., xn` are the elements of this collection or iterator. Returns `z` if this collection or iterator is empty.

9.  abstract def foldRight[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this collection or iterator. Returns `z` if this collection or iterator is empty.

10.  abstract def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this collection or iterator.

    Tests whether a predicate holds for all elements of this collection or iterator.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if this collection or iterator is empty or the given predicate `p` holds for all elements of this collection or iterator, otherwise `false`.

11.  abstract def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      Any
12.  abstract def hasDefiniteSize: Boolean

    Tests whether this collection or iterator is known to have a finite size.

    Tests whether this collection or iterator is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

    Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

13.  abstract def isEmpty: Boolean

    Tests whether the collection or iterator is empty.

    Tests whether the collection or iterator is empty.

    Note: Implementations in subclasses that are not repeatedly traversable must take care not to consume any elements when `isEmpty` is called.

    returns

      `true` if the collection or iterator contains no elements, `false` otherwise.

14.  abstract def isTraversableAgain: Boolean

    Tests whether this collection or iterator can be repeatedly traversed.

    Tests whether this collection or iterator can be repeatedly traversed. Always true for Traversables and false for Iterators unless overridden.

    returns

      `true` if it is repeatedly traversable, `false` otherwise.

15.  abstract def mkString: String

    Displays all elements of this collection or iterator in a string.

    Displays all elements of this collection or iterator in a string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator follow each other without any separator string.

16.  abstract def mkString(sep: String): String

    Displays all elements of this collection or iterator in a string using a separator string.

    Displays all elements of this collection or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

17.  abstract def mkString(start: String, sep: String, end: String): String

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this collection or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

18.  abstract def nonEmpty: Boolean

    Tests whether the collection or iterator is not empty.

    Tests whether the collection or iterator is not empty.

    returns

      `true` if the collection or iterator contains at least one element, `false` otherwise.

19.  abstract def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection or iterator is nonempty.

    Exceptions thrown

      `UnsupportedOperationException` if this collection or iterator is empty.

20.  abstract def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` if this collection or iterator is nonempty, `None` otherwise.

21.  abstract def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

22.  abstract def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

    Exceptions thrown

      `UnsupportedOperationException` if this collection or iterator is empty.

23.  abstract def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` if this collection or iterator is nonempty, `None` otherwise.

24.  abstract def seq: TraversableOnce[A]
25.  abstract def size: Int

    The size of this collection or iterator.

    The size of this collection or iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this collection or iterator.

26.  abstract def toBuffer[A1 >: A]: Buffer[A1]

    Uses the contents of this collection or iterator to create a new mutable buffer.

    Uses the contents of this collection or iterator to create a new mutable buffer.

    Note: will not terminate for infinite-sized collections.

    returns

      a buffer containing all elements of this collection or iterator.

27.  abstract def toIndexedSeq: immutable.IndexedSeq[A]

    Converts this collection or iterator to an indexed sequence.

    Converts this collection or iterator to an indexed sequence.

    Note: will not terminate for infinite-sized collections.

    returns

      an indexed sequence containing all elements of this collection or iterator.

28.  abstract def toIterable: GenIterable[A]

    Converts this collection or iterator to an iterable collection.

    Converts this collection or iterator to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

    Note: will not terminate for infinite-sized collections.

    returns

      an `Iterable` containing all elements of this collection or iterator.

29.  abstract def toIterator: Iterator[A]

    Returns an Iterator over the elements in this collection or iterator.

    Returns an Iterator over the elements in this collection or iterator. Will return the same Iterator if this instance is already an Iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      an Iterator containing all elements of this collection or iterator.

30.  abstract def toList: List[A]

    Converts this collection or iterator to a list.

    Converts this collection or iterator to a list.

    Note: will not terminate for infinite-sized collections.

    returns

      a list containing all elements of this collection or iterator.

31.  abstract def toSeq: GenSeq[A]

    Converts this collection or iterator to a sequence.

    Converts this collection or iterator to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

    Note: will not terminate for infinite-sized collections.

    returns

      a sequence containing all elements of this collection or iterator.

32.  abstract def toSet[A1 >: A]: GenSet[A1]

    Converts this collection or iterator to a set.

    Converts this collection or iterator to a set.

    Note: will not terminate for infinite-sized collections.

    returns

      a set containing all elements of this collection or iterator.

33.  abstract def toStream: Stream[A]

    Converts this collection or iterator to a stream.

    Converts this collection or iterator to a stream.

    returns

      a stream containing all elements of this collection or iterator.

34.  abstract def toTraversable: GenTraversable[A]

    Converts this collection or iterator to an unspecified Traversable.

    Converts this collection or iterator to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

    Note: will not terminate for infinite-sized collections.

    returns

      a Traversable containing all elements of this collection or iterator.

35.  abstract def toVector: Vector[A]

    Converts this collection or iterator to a Vector.

    Converts this collection or iterator to a Vector.

    Note: will not terminate for infinite-sized collections.

    returns

      a vector containing all elements of this collection or iterator.

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from GenTraversableOnce[A] to any2stringadd[GenTraversableOnce[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (GenTraversableOnce[A], B)
   Implicit
     This member is added by an implicit conversion from GenTraversableOnce[A] to ArrowAssoc[GenTraversableOnce[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any
6.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7.  abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

   [use case] Copies the elements of this collection or iterator to an array.

   [use case]

   Copies the elements of this collection or iterator to an array. Fills the given array `xs` with at most `len` elements of this collection or iterator, starting at position `start`. Copying will stop once either the end of the current collection or iterator is reached, or the end of the target array is reached, or `len` elements have been copied.

   Note: will not terminate for infinite-sized collections.

   xs

     the array to fill.

   start

     the starting index.

   len

     the maximal number of elements to copy.

    Full Signature

   #### abstract def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

8.  abstract def copyToArray(xs: Array[A], start: Int): Unit

   [use case] Copies the elements of this collection or iterator to an array.

   [use case]

   Copies the elements of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator, beginning at index `start`. Copying will stop once either the end of the current collection or iterator is reached, or the end of the target array is reached.

   Note: will not terminate for infinite-sized collections.

   xs

     the array to fill.

   start

     the starting index.

    Full Signature

   #### abstract def copyToArray[B >: A](xs: Array[B], start: Int): Unit

9.  abstract def copyToArray(xs: Array[A]): Unit

   [use case] Copies the elements of this collection or iterator to an array.

   [use case]

   Copies the elements of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator. Copying will stop once either the end of the current collection or iterator is reached, or the end of the target array is reached.

   Note: will not terminate for infinite-sized collections.

   xs

     the array to fill.

    Full Signature

   #### abstract def copyToArray[B >: A](xs: Array[B]): Unit

10.  def ensuring(cond: (GenTraversableOnce[A]) ⇒ Boolean, msg: ⇒ Any): GenTraversableOnce[A]
    Implicit
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: (GenTraversableOnce[A]) ⇒ Boolean): GenTraversableOnce[A]
    Implicit
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean, msg: ⇒ Any): GenTraversableOnce[A]
    Implicit
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean): GenTraversableOnce[A]
    Implicit
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def equals(arg0: Any): Boolean

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Any implementation of this method should be an equivalence relation:

    - It is reflexive: for any instance `x` of type `Any`, `x.equals(x)` should return `true`.
    - It is symmetric: for any instances `x` and `y` of type `Any`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
    - It is transitive: for any instances `x`, `y`, and `z` of type `Any` if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.

    If you override this method, you should verify that your implementation remains an equivalence relation. Additionally, when overriding this method it is usually necessary to override `hashCode` to ensure that objects which are "equal" (`o1.equals(o2)` returns `true`) hash to the same scala.Int. (`o1.hashCode.equals(o2.hashCode)`).

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any
15.  abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this collection or iterator.

    [use case]

    Applies a function `f` to all elements of this collection or iterator.

    Note: this method underlies the implementation of most other bulk operations. It's important to implement this method in an efficient way.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

     Full Signature

    #### abstract def foreach[U](f: (A) ⇒ U): Unit

16.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from GenTraversableOnce[A] to StringFormat[GenTraversableOnce[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
17.  def hashCode(): Int

    Calculate a hash code value for the object.

    Calculate a hash code value for the object.

    The default hashing algorithm is platform dependent.

    Note that it is allowed for two objects to have identical hash codes (`o1.hashCode.equals(o2.hashCode)`) yet not be equal (`o1.equals(o2)` returns `false`). A degenerate implementation could always return `0`. However, it is required that if two objects are equal (`o1.equals(o2)` returns `true`) that they have identical hash codes (`o1.hashCode.equals(o2.hashCode)`). Therefore, when overriding this method, be sure to verify that the behavior is consistent with the `equals` method.

    returns

      the hash code value for this object.

    Definition Classes
      Any
18.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
19.  abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this collection or iterator.

     Full Signature

    #### abstract def max[A1 >: A](implicit ord: Ordering[A1]): A

20.  abstract def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this collection or iterator with the largest value measured by function f.

     Full Signature

    #### abstract def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

21.  abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this collection or iterator

     Full Signature

    #### abstract def min[A1 >: A](implicit ord: Ordering[A1]): A

22.  abstract def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this collection or iterator with the smallest value measured by function f.

     Full Signature

    #### abstract def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

23.  abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this collection or iterator of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the collection or iterator and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Full Signature

    #### abstract def product[A1 >: A](implicit num: Numeric[A1]): A1

24.  def sizeHintIfCheap: Int

    The size of this collection or iterator, if it can be cheaply computed

    The size of this collection or iterator, if it can be cheaply computed

    returns

      the number of elements in this collection or iterator, or -1 if the size cannot be determined cheaply

    Attributes
      protected[scala.collection]
25.  abstract def sum: A

    [use case] Sums up the elements of this collection.

    [use case]

    Sums up the elements of this collection.

    returns

      the sum of all elements in this collection or iterator of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the collection or iterator and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Full Signature

    #### abstract def sum[A1 >: A](implicit num: Numeric[A1]): A1

26.  abstract def to[Col[_]]: Col[A]

    [use case] Converts this collection or iterator into another by copying all elements.

    [use case]

    Converts this collection or iterator into another by copying all elements.

    Note: will not terminate for infinite-sized collections.

    Col

      The collection type to build.

    returns

      a new collection containing all elements of this collection or iterator.

     Full Signature

    #### abstract def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

27.  abstract def toArray: Array[A]

    [use case] Converts this collection or iterator to an array.

    [use case]

    Converts this collection or iterator to an array.

    Note: will not terminate for infinite-sized collections.

    returns

      an array containing all elements of this collection or iterator. An `ClassTag` must be available for the element type of this collection or iterator.

     Full Signature

    #### abstract def toArray[A1 >: A](implicit arg0: ClassTag[A1]): Array[A1]

28.  abstract def toMap[T, U]: Map[T, U]

    [use case] Converts this collection or iterator to a map.

    [use case]

    Converts this collection or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this collection or iterator.

     Full Signature

    #### abstract def toMap[K, V](implicit ev: <:<[A, (K, V)]): GenMap[K, V]

29.  def toString(): String

    Returns a string representation of the object.

    Returns a string representation of the object.

    The default representation is platform dependent.

    returns

      a string representation of the object.

    Definition Classes
      Any
30.  def →[B](y: B): (GenTraversableOnce[A], B)
    Implicit
      This member is added by an implicit conversion from GenTraversableOnce[A] to ArrowAssoc[GenTraversableOnce[A]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Any

### Inherited by implicit conversion any2stringadd from GenTraversableOnce[A] to any2stringadd[GenTraversableOnce[A]]

### Inherited by implicit conversion StringFormat from GenTraversableOnce[A] to StringFormat[GenTraversableOnce[A]]

### Inherited by implicit conversion Ensuring from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]]

### Inherited by implicit conversion ArrowAssoc from GenTraversableOnce[A] to ArrowAssoc[GenTraversableOnce[A]]

### Ungrouped